﻿// https://www.reddit.com/r/Unity3D/comments/4r1g2a/howto_pulse_in_time_with_music_at_a_fixed_bpm/
// https://pastebin.com/SYjU3QQ0

using System.Collections;
using UnityEngine;

[RequireComponent(typeof(AudioSource))]
public class BeatPulse : MonoBehaviour {

    public float BPM = 100f;
    public Color StartColor;
    public Color EndColor;
    private Material mat;

    // Use this for initialization
    void Start()
    {
        mat = GetComponent<Renderer>().material;
    }

    // Update is called once per frame
    void Update()
    {
           //AudioSettings.dspTime
           //var baseValue = Mathf.Cos(((Time.time * Mathf.PI) * (BPM / 60f)) % Mathf.PI);
           var baseValue = Mathf.Cos((((float)AudioSettings.dspTime * Mathf.PI) * (BPM / 60f)) % Mathf.PI);
        var target = Color.Lerp(EndColor, StartColor, baseValue);
        mat.SetColor("_Color", target);
    }
}