﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;

public class ChangeScene : MonoBehaviour {

    public int levels = 3;

    private int lastLevel = 0;
    private int currentLevel = 0;
    private bool islocked = false;

    private float fadeTime;

    //private string[] sceneList = new string[] { "scene", "scene2", "scene3" };

	// Use this for initialization
	void Start () {
        islocked = false;
        print("CURRENT LEVEL: " + SceneManager.GetActiveScene().buildIndex);
        currentLevel = SceneManager.GetActiveScene().buildIndex;
        //GameObject.Find("_Scene").GetComponent<Fade>().BeginFade(-1);
    }

    // Update is called once per frame
    void Update()
    {

        lastLevel = currentLevel;

        if (!islocked)
        {
            if (Input.GetKey("right"))
            {
                if (currentLevel < (levels-1) )
                {
                    islocked = true;
                    currentLevel = currentLevel + 1;
                }
            }
            else if (Input.GetKey("left"))
            {
                if (currentLevel > 0)
                {
                    islocked = true;
                    currentLevel = currentLevel - 1;
                }
            }

            if (lastLevel != currentLevel)
            {
                //GameObject.Find("_Scene").GetComponent<Fade>().BeginFade(-1);
                //fadeTime = GameObject.Find("_Scene").GetComponent<Fade>().BeginFade(1);
                
                //SceneManager.LoadScene(currentLevel);
                StartCoroutine(CheckLevelUpdate());
            }
        }
    }

    private IEnumerator CheckLevelUpdate()
    {
        yield return StartCoroutine(FadeScene());
        yield return StartCoroutine(LoadScene());
        //        float fadeTime = GameObject.Find("_Scene").GetComponent<Fade>().BeginFade(1);
        //        yield return new WaitForSeconds(fadeTime);
        //        SceneManager.LoadScene(currentLevel);
        //StartCoroutine(LoadScene());
    }

    private IEnumerator FadeScene()
    {
        fadeTime = GameObject.Find("_Scene").GetComponent<Fade>().BeginFade(1);
        yield return new WaitForSeconds(fadeTime);
    }
    private IEnumerator LoadScene()
    {
        SceneManager.LoadScene(currentLevel);
        yield return new WaitForSeconds(fadeTime);

    }
    private IEnumerator AsyncLoadScene()
    {
        // The Application loads the Scene in the background at the same time as the current Scene.
        //This is particularly good for creating loading screens. You could also load the Scene by build //number.
        AsyncOperation asyncLoad = SceneManager.LoadSceneAsync(currentLevel);
        //Wait until the last operation fully loads to return anything
        while (!asyncLoad.isDone)
        {
            yield return null;
        }
    }
}
